/**
 * @author xuweihua
 * 下载任务队列
 * addTask
 * startTask
 */

var uexDownloadTaskMgr = {};
uexDownloadTaskMgr.init = function(data, cb){
    uexDownloadTaskMgr = (function(me,uexDownloaderMgr){
        var self = this;
        var _id_max = 65536;
        var _id = 10;
        function getOptionId(){
            return _id = (_id + 1) % _id_max;
        };
        me.getOptionId = function() {
            return getOptionId();
        };
        
        me.debug = false;
        
        var taskMap = {};
        var taskComplete;
        
        var file_exist_by_cache = '1';
        var file_exist_by_download = '0';
        
        uexDownloaderMgr.onStatus = function(opCode, fileSize, percent, status) {
            var task = taskMap[''+opCode];
            switch (status) {
                case 0 :
                    log('download success:'+opCode+': percent-'+percent);
                    break;
                case 1 :
                    log('download success:'+opCode+':'+task.url);
                    uexDownloaderMgr.closeDownloader(opCode);
                    //setTimeout(function(){
                        task.cb(file_exist_by_download, fileSize, percent, status, opCode);
                    //},50);
                    clearTask(opCode);
                    break;
                case 2 :
                    log('download faild:'+opCode+':'+task.url);
                    uexDownloaderMgr.closeDownloader(opCode);
                    task.cb(file_exist_by_download, fileSize, percent, status, opCode);
                    clearTask(opCode);
                    break;
            }
            return;
        };
        
        uexDownloaderMgr.cbCreateDownloader = function(opCode, dataType, data) {
            if (data == 0) {
                var task = taskMap[opCode];
                log('createDownloader success:{}, start downloading ..., path:{}, url:{}', opCode, task.path, task.url);
                uexDownloaderMgr.download(opCode, task.url, task.path, 0);
            } else {
                uexDownloaderMgr.closeDownloader(opCode);
            }
        };
        
        me.addTask = function(obj){
            var id = getOptionId();
            taskMap[''+id] = obj;
            log('addTask:'+JSON.stringify(obj));
        }
        me.startTask = function(finalTask){
            taskComplete = finalTask;
            doTask();
        }
        uexFileMgr.cbIsFileExistByPath=function(opid,dataType,data){
            if(data == 0){
                log('file not found, download ...');
                uexDownloaderMgr.createDownloader(opid);
            }else if(data == 1){
                log('file exist');
                var task = taskMap[opid];
                if(task){
                    task.cb(file_exist_by_cache, '', '', '', task.path);
                }
                clearTask(opid);
            }
        }
        function doTask(){
            var task, id, isFinal=1;
            for(var id in taskMap){
                isFinal = 0;
                if(taskMap.hasOwnProperty(id)){
                    task = taskMap[id];
                    uexFileMgr.isFileExistByPath(id, task.path);
                }
                break;
            }
            if(isFinal){
                if(taskComplete){
                    var cb = taskComplete();
                    taskComplete = null;
                    cb();
                }
            }
        }
        
        function clearTask(opCode){
            delete taskMap[''+opCode];
            log('clear and do next');
            doTask();
        }
        
        return me;
        
    }(uexDownloadTaskMgr||{},uexDownloaderMgr));
}
